

JSON.serializeForm = function(form) {
	var undef, el, step, key, value
	, res = {}
	, i = 0

	// Disabled controls do not receive focus,
	// are skipped in tabbing navigation, cannot be successfully posted.
	//
	// Read-only elements receive focus but cannot be modified by the user,
	// are included in tabbing navigation, are successfully posted.

	for (; el = form.elements[i++]; ) if ((key = el.name || el.id) && !el.disabled) {
		value = el.type == "checkbox" || el.type == "radio" ?
		(el.checked ? el.value == "on" || el.value : undef) :
		el.type == "select-multiple" ?
		readOption(el) :
		el.value

		if (value !== undef) {
			step = res
			key.replace(/\[(.*?)\]/g, function(_, _key, offset) {
				if (step == res) key = key.slice(0, offset)
				step = step[key] || (step[key] = _key && _key != 0 ? {} : [])
				key = _key
			})
			step[key || step.length] = value
		}
	}

	return res

	function readOption(el) {
		for (var node, arr = [], i = 0; node = el.options[i++]; ) {
			if (node.selected) arr.push(node.value)
		}
		return arr
	}
}


